#ifndef HW3_GN_34804D67
#define HW3_GN_34804D67

struct GaussNewtonParams{
	GaussNewtonParams() :
		exact_line_search(false),
		gradient_tolerance(1e-5),
		residual_tolerance(1e-5),
		max_iter(1000),
		verbose(false)
	{}
	bool exact_line_search; // ʹþȷǽ
	double gradient_tolerance; // ݶֵǰݶСֵʱֹͣ
	double residual_tolerance; // ֵǰСֵʱֹͣ
	int max_iter; // 
	bool verbose; // ǷӡÿϢ
};

struct GaussNewtonReport {
	enum StopType {
		STOP_GRAD_TOL,       // ݶȴﵽֵ
		STOP_RESIDUAL_TOL,   // ﵽֵ
		STOP_NO_CONVERGE,    // 
		STOP_NUMERIC_FAILURE // ֵ
	};
	StopType stop_type; // Żֹԭ
	double n_iter;      // 
};

class ResidualFunction {
public:
	virtual int nR() const = 0;
	virtual int nX() const = 0;
	virtual void eval(double *R, double *J, double *X) = 0;
};

class GaussNewtonSolver {
public:
	virtual double solve(
		ResidualFunction *f, // Ŀ꺯
		double *X,           // ΪֵΪ
		GaussNewtonParams param = GaussNewtonParams(), // Ż
		GaussNewtonReport *report = nullptr // Ż
		) = 0;
};

#endif /* HW3_GN_34804D67 */
